<?php

namespace DataView;

class Fop_chat {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
									
									function updateNumberfop_chat(col) {
										//var checklist = window.DataViewChecked['fop_chat'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_chat'] && window.DataViewChecked['fop_chat'][col].ranges.length > 0) {
											$('.fop_chat__mass-action').css('visibility', 'visible');
											$('.fop_chat__action').css('visibility', 'hidden');
										} else {
											$('.fop_chat__mass-action').css('visibility', 'hidden');
											$('.fop_chat__action').css('visibility', 'visible');
										}
										$('.fop_chat__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_chat__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_chat__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_chat (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_chat/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if (((\FOP\User::getMitglied())) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_chat/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_chat-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_chat-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_chat-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_chat('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_chat-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_chat()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_chat (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_chat']) window.DataViewChecked['fop_chat'] = {};
										if (!window.DataViewChecked['fop_chat'][col]) window.DataViewChecked['fop_chat'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_chat'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_chat({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_chat'][col] = new IDList(ids);
													updateNumberfop_chat(col);
												});
											} else {
												window.DataViewChecked['fop_chat'][col] = new IDList();
												updateNumberfop_chat(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_chat__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_chat'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_chat'][col].push(id);
												} else {
													window.DataViewChecked['fop_chat'][col].remove(id);
												}
											}
											updateNumberfop_chat(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_chat();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if(((\FOP\User::getMitglied()))) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadfop_chat({action: 'open', fop_table: 'fop_chat', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Fop_chat::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('Chat-Nachricht'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_chat']) ? intval($_GET['page_fop_chat']) : 0);
								$addlines = (isset($_GET['addlines_fop_chat']) ? intval($_GET['addlines_fop_chat']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'ItemId',
												'desc' => _('ItemID'),
												'order' => ++$order,
												'width' => 60, // default value
												'collapsed' => 0

											];
											$columns['ItemId'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'Sender',
												'desc' => _('Sender'),
												'order' => ++$order,
												'width' => 60, // default value
												'collapsed' => 0

											];
											$columns['Sender'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'Message',
												'desc' => _('Nachricht'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['Message'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'ReportCount',
												'desc' => _('Report-Count'),
												'order' => ++$order,
												'width' => 60, // default value
												'collapsed' => 0

											];
											$columns['ReportCount'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'Timestamp',
												'desc' => _('Zeit'),
												'order' => ++$order,
												'width' => 160, // default value
												'collapsed' => 0

											];
											$columns['Timestamp'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'table',
												'desc' => _('Tabelle'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['table'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_chat'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='ItemId'
												data-order='<?php echo intval($columns['ItemId']['order']); ?>'
												data-width='<?php echo intval($columns['ItemId']['width']); ?>'
												data-collapsed='<?php echo intval($columns['ItemId']['collapsed']); ?>'
												style='width: <?php echo intval($columns['ItemId']['width']); ?>px; <?php if ($columns['ItemId']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_chat(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_fop_chat_ItemId']).on('change keyup paste', function () { query['range_min_fop_chat_ItemId'] = von.val(); delete query['page_fop_chat']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_fop_chat_ItemId']).on('change keyup paste', function () { query['range_max_fop_chat_ItemId'] = bis.val(); delete query['page_fop_chat']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_chat'] == 'ItemId ASC') {
			query['sort_fop_chat'] = 'ItemId DESC';
		 } else if (query['sort_fop_chat'] == 'ItemId DESC') {
		 	delete query['sort_fop_chat'];
		 } else {
			query['sort_fop_chat'] = 'ItemId ASC';
		 }
		 reloadfop_chat();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('ItemID')); ?>'><?php echo(_('ItemID')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'ItemId ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'ItemId DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_chat_ItemId']) || isset($_GET['range_max_fop_chat_ItemId']) || isset($_GET['deps_fop_chat_ItemId']) || isset($_GET['fullsearch_fop_chat_ItemId']) || isset($_GET['dynamic_fop_chat_ItemId']) || isset($_GET['search_fop_chat_ItemId']) || isset($_GET['searchnot_fop_chat_ItemId']) || isset($_GET['filter_fop_chat_ItemId'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['ItemId']['header'] = ob_get_contents(); ob_end_clean();
											$columns['ItemId']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['ItemId']['width']); ?>px; <?php if ($columns['ItemId']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='ItemId'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Integer::print($item['ItemId'])); ?>
	</span></div><?php
											};
											$columns['ItemId']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='ItemId'
													data-order='<?php echo intval($columns['ItemId']['order']); ?>'
													data-width='<?php echo intval($columns['ItemId']['width']); ?>'
													data-collapsed='<?php echo intval($columns['ItemId']['collapsed']); ?>'
													style='width: <?php echo intval($columns['ItemId']['width']); ?>px; <?php if ($columns['ItemId']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='Sender'
												data-order='<?php echo intval($columns['Sender']['order']); ?>'
												data-width='<?php echo intval($columns['Sender']['width']); ?>'
												data-collapsed='<?php echo intval($columns['Sender']['collapsed']); ?>'
												style='width: <?php echo intval($columns['Sender']['width']); ?>px; <?php if ($columns['Sender']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_chat(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_fop_chat_Sender']).on('change keyup paste', function () { query['range_min_fop_chat_Sender'] = von.val(); delete query['page_fop_chat']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_fop_chat_Sender']).on('change keyup paste', function () { query['range_max_fop_chat_Sender'] = bis.val(); delete query['page_fop_chat']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_chat'] == 'Sender ASC') {
			query['sort_fop_chat'] = 'Sender DESC';
		 } else if (query['sort_fop_chat'] == 'Sender DESC') {
		 	delete query['sort_fop_chat'];
		 } else {
			query['sort_fop_chat'] = 'Sender ASC';
		 }
		 reloadfop_chat();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('Sender')); ?>'><?php echo(_('Sender')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'Sender ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'Sender DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_chat_Sender']) || isset($_GET['range_max_fop_chat_Sender']) || isset($_GET['deps_fop_chat_Sender']) || isset($_GET['fullsearch_fop_chat_Sender']) || isset($_GET['dynamic_fop_chat_Sender']) || isset($_GET['search_fop_chat_Sender']) || isset($_GET['searchnot_fop_chat_Sender']) || isset($_GET['filter_fop_chat_Sender'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['Sender']['header'] = ob_get_contents(); ob_end_clean();
											$columns['Sender']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['Sender']['width']); ?>px; <?php if ($columns['Sender']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='Sender'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Integer::print($item['Sender'])); ?>
	</span></div><?php
											};
											$columns['Sender']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='Sender'
													data-order='<?php echo intval($columns['Sender']['order']); ?>'
													data-width='<?php echo intval($columns['Sender']['width']); ?>'
													data-collapsed='<?php echo intval($columns['Sender']['collapsed']); ?>'
													style='width: <?php echo intval($columns['Sender']['width']); ?>px; <?php if ($columns['Sender']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='Message'
												data-order='<?php echo intval($columns['Message']['order']); ?>'
												data-width='<?php echo intval($columns['Message']['width']); ?>'
												data-collapsed='<?php echo intval($columns['Message']['collapsed']); ?>'
												style='width: <?php echo intval($columns['Message']['width']); ?>px; <?php if ($columns['Message']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_chat(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_chat_Message'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_chat_Message'] = text.val(); } else { delete query['search_fop_chat_Message']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_chat').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_chat_Message'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_chat_Message'] = text2.val(); } else { delete query['searchnot_fop_chat_Message']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_chat').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_chat'] == 'Message ASC') {
			query['sort_fop_chat'] = 'Message DESC';
		 } else if (query['sort_fop_chat'] == 'Message DESC') {
		 	delete query['sort_fop_chat'];
		 } else {
			query['sort_fop_chat'] = 'Message ASC';
		 }
		 reloadfop_chat();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Nachricht')); ?>'><?php echo(_('Nachricht')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'Message ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'Message DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_chat_Message']) || isset($_GET['range_max_fop_chat_Message']) || isset($_GET['deps_fop_chat_Message']) || isset($_GET['fullsearch_fop_chat_Message']) || isset($_GET['dynamic_fop_chat_Message']) || isset($_GET['search_fop_chat_Message']) || isset($_GET['searchnot_fop_chat_Message']) || isset($_GET['filter_fop_chat_Message'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['Message']['header'] = ob_get_contents(); ob_end_clean();
											$columns['Message']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['Message']['width']); ?>px; <?php if ($columns['Message']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='Message'><span class='overflow-text' title="<?php echo htmlentities($item['Message']); ?>"><?php echo htmlentities($item['Message']); ?></span></div><?php
											};
											$columns['Message']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='Message'
													data-order='<?php echo intval($columns['Message']['order']); ?>'
													data-width='<?php echo intval($columns['Message']['width']); ?>'
													data-collapsed='<?php echo intval($columns['Message']['collapsed']); ?>'
													style='width: <?php echo intval($columns['Message']['width']); ?>px; <?php if ($columns['Message']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='ReportCount'
												data-order='<?php echo intval($columns['ReportCount']['order']); ?>'
												data-width='<?php echo intval($columns['ReportCount']['width']); ?>'
												data-collapsed='<?php echo intval($columns['ReportCount']['collapsed']); ?>'
												style='width: <?php echo intval($columns['ReportCount']['width']); ?>px; <?php if ($columns['ReportCount']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_chat(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_fop_chat_ReportCount']).on('change keyup paste', function () { query['range_min_fop_chat_ReportCount'] = von.val(); delete query['page_fop_chat']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_fop_chat_ReportCount']).on('change keyup paste', function () { query['range_max_fop_chat_ReportCount'] = bis.val(); delete query['page_fop_chat']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_chat'] == 'ReportCount ASC') {
			query['sort_fop_chat'] = 'ReportCount DESC';
		 } else if (query['sort_fop_chat'] == 'ReportCount DESC') {
		 	delete query['sort_fop_chat'];
		 } else {
			query['sort_fop_chat'] = 'ReportCount ASC';
		 }
		 reloadfop_chat();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('Report-Count')); ?>'><?php echo(_('Report-Count')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'ReportCount ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'ReportCount DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_chat_ReportCount']) || isset($_GET['range_max_fop_chat_ReportCount']) || isset($_GET['deps_fop_chat_ReportCount']) || isset($_GET['fullsearch_fop_chat_ReportCount']) || isset($_GET['dynamic_fop_chat_ReportCount']) || isset($_GET['search_fop_chat_ReportCount']) || isset($_GET['searchnot_fop_chat_ReportCount']) || isset($_GET['filter_fop_chat_ReportCount'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['ReportCount']['header'] = ob_get_contents(); ob_end_clean();
											$columns['ReportCount']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['ReportCount']['width']); ?>px; <?php if ($columns['ReportCount']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='ReportCount'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Integer::print($item['ReportCount'])); ?>
	</span></div><?php
											};
											$columns['ReportCount']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='ReportCount'
													data-order='<?php echo intval($columns['ReportCount']['order']); ?>'
													data-width='<?php echo intval($columns['ReportCount']['width']); ?>'
													data-collapsed='<?php echo intval($columns['ReportCount']['collapsed']); ?>'
													style='width: <?php echo intval($columns['ReportCount']['width']); ?>px; <?php if ($columns['ReportCount']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='Timestamp'
												data-order='<?php echo intval($columns['Timestamp']['order']); ?>'
												data-width='<?php echo intval($columns['Timestamp']['width']); ?>'
												data-collapsed='<?php echo intval($columns['Timestamp']['collapsed']); ?>'
												style='width: <?php echo intval($columns['Timestamp']['width']); ?>px; <?php if ($columns['Timestamp']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_chat(); 
		}}, 600);
		date_filter(win, 'fop_chat', 'Timestamp', <?php echo htmlentities(json_encode(_('period'))); ?>, <?php echo htmlentities(json_encode(\FOP\I18n::getShortLocale())); ?>, <?php echo htmlentities(json_encode(_('dateformat_moment'))); ?>, function() { reloadfop_chat();  reloadfop_chat(); });
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_chat'] == 'Timestamp ASC') {
			query['sort_fop_chat'] = 'Timestamp DESC';
		 } else if (query['sort_fop_chat'] == 'Timestamp DESC') {
		 	delete query['sort_fop_chat'];
		 } else {
			query['sort_fop_chat'] = 'Timestamp ASC';
		 }
		 reloadfop_chat();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Zeit')); ?>'><?php echo(_('Zeit')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'Timestamp ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'Timestamp DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_chat_Timestamp']) || isset($_GET['range_max_fop_chat_Timestamp']) || isset($_GET['deps_fop_chat_Timestamp']) || isset($_GET['fullsearch_fop_chat_Timestamp']) || isset($_GET['dynamic_fop_chat_Timestamp']) || isset($_GET['search_fop_chat_Timestamp']) || isset($_GET['searchnot_fop_chat_Timestamp']) || isset($_GET['filter_fop_chat_Timestamp'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['Timestamp']['header'] = ob_get_contents(); ob_end_clean();
											$columns['Timestamp']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['Timestamp']['width']); ?>px; <?php if ($columns['Timestamp']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='Timestamp'><span class='overflow-text' title="<?php echo htmlentities(($item['Timestamp']) ? strftime(_('datetimeformat_php2'), intval($item['Timestamp'])) : ''); ?>"><?php echo htmlentities(($item['Timestamp']) ? strftime(_('datetimeformat_php2'), intval($item['Timestamp'])) : ''); ?></span></div><?php
											};
											$columns['Timestamp']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='Timestamp'
													data-order='<?php echo intval($columns['Timestamp']['order']); ?>'
													data-width='<?php echo intval($columns['Timestamp']['width']); ?>'
													data-collapsed='<?php echo intval($columns['Timestamp']['collapsed']); ?>'
													style='width: <?php echo intval($columns['Timestamp']['width']); ?>px; <?php if ($columns['Timestamp']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='table'
												data-order='<?php echo intval($columns['table']['order']); ?>'
												data-width='<?php echo intval($columns['table']['width']); ?>'
												data-collapsed='<?php echo intval($columns['table']['collapsed']); ?>'
												style='width: <?php echo intval($columns['table']['width']); ?>px; <?php if ($columns['table']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_chat(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_chat_table'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_chat_table'] = text.val(); } else { delete query['search_fop_chat_table']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_chat').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_chat_table'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_chat_table'] = text2.val(); } else { delete query['searchnot_fop_chat_table']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_chat').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_chat'] == 'table ASC') {
			query['sort_fop_chat'] = 'table DESC';
		 } else if (query['sort_fop_chat'] == 'table DESC') {
		 	delete query['sort_fop_chat'];
		 } else {
			query['sort_fop_chat'] = 'table ASC';
		 }
		 reloadfop_chat();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Tabelle')); ?>'><?php echo(_('Tabelle')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'table ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_chat']) && $_GET['sort_fop_chat'] == 'table DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_chat_table']) || isset($_GET['range_max_fop_chat_table']) || isset($_GET['deps_fop_chat_table']) || isset($_GET['fullsearch_fop_chat_table']) || isset($_GET['dynamic_fop_chat_table']) || isset($_GET['search_fop_chat_table']) || isset($_GET['searchnot_fop_chat_table']) || isset($_GET['filter_fop_chat_table'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['table']['header'] = ob_get_contents(); ob_end_clean();
											$columns['table']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['table']['width']); ?>px; <?php if ($columns['table']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='table'><span class='overflow-text' title="<?php echo htmlentities($item['table']); ?>"><?php echo htmlentities($item['table']); ?></span></div><?php
											};
											$columns['table']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='table'
													data-order='<?php echo intval($columns['table']['order']); ?>'
													data-width='<?php echo intval($columns['table']['width']); ?>'
													data-collapsed='<?php echo intval($columns['table']['collapsed']); ?>'
													style='width: <?php echo intval($columns['table']['width']); ?>px; <?php if ($columns['table']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_chat-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_chat-table .fop-table-header .fop-table-column .title,
										#fop_chat-table .fop-column-handle,
										#fop_chat-table .fop-table-row,
										#fop_chat-table .fop-table-row .fop-table-column,
										#fop_chat-table .fop-table-column-multicontrol,
										#fop_chat-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_chat">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_chat__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_chat__all-checkbox" type="checkbox" onchange="checkfop_chat('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_chat__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_chat/permissions?id=' + checkfop_chat(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_chat_') == 0 || key.indexOf('range_max_fop_chat_') == 0 || key.indexOf('deps_fop_chat_') == 0 || key.indexOf('fullsearch_fop_chat_') == 0 || key.indexOf('dynamic_fop_chat_') == 0 || key.indexOf('search_fop_chat_') == 0 || key.indexOf('searchnot_fop_chat_') == 0 || key.indexOf('filter_fop_chat_') == 0) delete query[key]; reloadfop_chat(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_chat_ID'] = checkfop_chat(null, 'ID'); delete query['page_fop_chat']; reloadfop_chat(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_chat(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_chat(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && ((false) && (\FOP\User::getMitglied()))) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_chat/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_chat(null, 'ID'))).then(function () { reloadfop_chat(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_chat', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_chat', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_chat" <?php \EasyEditor\Navigation::printScroll('dv.Fop_chat', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_chat\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_chat\'] = wantedPage;
														reloadfop_chat(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-fop_chat-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadfop_chat({action: \'open\', fop_table: \'fop_chat\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_chat__checkbox fop_chat__checkbox fop_chat__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_chat__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_chat__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_chat(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_chat__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_chat-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_chat::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadfop_chat({action: 'open', fop_table: 'fop_chat', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_chat::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_chat/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_chat(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_chat" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_chat::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_chat();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_chat" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Fop_chat::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadfop_chat({action: 'open', fop_table: 'fop_chat', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadfop_chat();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE ((FALSE) AND ('.\FOP\Database::quote(\FOP\User::getMitglied()).')) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_chat').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* ItemId */ '.qi('ItemId').' AS '.qi('ItemId').',
									/* Message */ '.qi('Message').' AS '.qi('Message').',
									/* ReportCount */ '.qi('ReportCount').' AS '.qi('ReportCount').',
									/* Sender */ '.qi('Sender').' AS '.qi('Sender').',
									/* Timestamp */ '.qi('Timestamp').' AS '.qi('Timestamp').',
									/* operation::5a81af87737a91fddc7e5ca3b6e5661f1118a77b491f64f5e16676d1448b78b1 */ (('.qi('fop_chat').'.'.qi('ReportCount').') > (0)) AS '.qi('operation::5a81af87737a91fddc7e5ca3b6e5661f1118a77b491f64f5e16676d1448b78b1').',
									/* operation::create */ ' . ((\FOP\User::getMitglied()) ? 1 : 0) . ' AS '.qi('operation::create').',
									/* operation::delete */ (FALSE) AND ('.\FOP\Database::quote(\FOP\User::getMitglied()).') AS '.qi('operation::delete').',
									/* operation::edit */ (FALSE) AND ('.\FOP\Database::quote(\FOP\User::getMitglied()).') AS '.qi('operation::edit').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ ('.\FOP\Database::quote(\FOP\User::getMitglied()).') AS '.qi('operation::view').',
									/* table */ '.qi('table').' AS '.qi('table').',
									1
								FROM '.qi('fop_chat').' '.qi('fop_chat').'
								WHERE ((('.\FOP\Database::quote(\FOP\User::getMitglied()).')))) AS t
								WHERE ' . (isset($params['range_min_fop_chat_ItemId']) ? ($params['range_min_fop_chat_ItemId'] !== '' && is_numeric($params['range_min_fop_chat_ItemId']) ? 't.'.qi('ItemId').' >= ' . \FOP\Database::quote($params['range_min_fop_chat_ItemId']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_chat_Sender']) ? ($params['range_min_fop_chat_Sender'] !== '' && is_numeric($params['range_min_fop_chat_Sender']) ? 't.'.qi('Sender').' >= ' . \FOP\Database::quote($params['range_min_fop_chat_Sender']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_chat_ReportCount']) ? ($params['range_min_fop_chat_ReportCount'] !== '' && is_numeric($params['range_min_fop_chat_ReportCount']) ? 't.'.qi('ReportCount').' >= ' . \FOP\Database::quote($params['range_min_fop_chat_ReportCount']) . ' AND ' : '') : '') . 
								(isset($params['range_min_fop_chat_Timestamp']) ? ($params['range_min_fop_chat_Timestamp'] !== '' && is_numeric($params['range_min_fop_chat_Timestamp']) ? 't.'.qi('Timestamp').' >= ' . \FOP\Database::quote($params['range_min_fop_chat_Timestamp']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_chat_ItemId']) ? ($params['range_max_fop_chat_ItemId'] !== '' && is_numeric($params['range_max_fop_chat_ItemId']) ? 't.'.qi('ItemId').' <= ' . \FOP\Database::quote($params['range_max_fop_chat_ItemId']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_chat_Sender']) ? ($params['range_max_fop_chat_Sender'] !== '' && is_numeric($params['range_max_fop_chat_Sender']) ? 't.'.qi('Sender').' <= ' . \FOP\Database::quote($params['range_max_fop_chat_Sender']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_chat_ReportCount']) ? ($params['range_max_fop_chat_ReportCount'] !== '' && is_numeric($params['range_max_fop_chat_ReportCount']) ? 't.'.qi('ReportCount').' <= ' . \FOP\Database::quote($params['range_max_fop_chat_ReportCount']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_chat_Timestamp']) ? ($params['range_max_fop_chat_Timestamp'] !== '' && is_numeric($params['range_max_fop_chat_Timestamp']) ? 't.'.qi('Timestamp').' <= ' . \FOP\Database::quote($params['range_max_fop_chat_Timestamp']) . ' AND ' : '') : '') . 
								(isset($params['filter_fop_chat_ItemId']) ? ($params['filter_fop_chat_ItemId'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_ItemId']))->toSQL('t.'.qi('ItemId').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_chat_Sender']) ? ($params['filter_fop_chat_Sender'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_Sender']))->toSQL('t.'.qi('Sender').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_chat_Message']) ? ($params['filter_fop_chat_Message'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_Message']))->toSQL('t.'.qi('Message').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_chat_ReportCount']) ? ($params['filter_fop_chat_ReportCount'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_ReportCount']))->toSQL('t.'.qi('ReportCount').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_chat_Timestamp']) ? ($params['filter_fop_chat_Timestamp'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_Timestamp']))->toSQL('t.'.qi('Timestamp').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_chat_table']) ? ($params['filter_fop_chat_table'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_table']))->toSQL('t.'.qi('table').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_chat_ID']) ? ($params['filter_fop_chat_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_chat_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_fop_chat_Message']) ? 't.'.qi('Message').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_chat_Message'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_chat_table']) ? 't.'.qi('table').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_chat_table'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_chat_Message']) ? 'NOT t.'.qi('Message').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_chat_Message'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_chat_table']) ? 'NOT t.'.qi('table').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_chat_table'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_chat']) ? '(' . 't.'.qi('Message').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_chat'] . '%') . ' OR ' . 't.'.qi('table').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_chat'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'Message ASC' => 'ORDER BY t.'.qi('Message').' ASC',
									'table ASC' => 'ORDER BY t.'.qi('table').' ASC',
									'ItemId ASC' => 'ORDER BY t.'.qi('ItemId').' ASC',
									'Sender ASC' => 'ORDER BY t.'.qi('Sender').' ASC',
									'ReportCount ASC' => 'ORDER BY t.'.qi('ReportCount').' ASC',
									'Timestamp ASC' => 'ORDER BY t.'.qi('Timestamp').' ASC',
									'Message DESC' => 'ORDER BY t.'.qi('Message').' DESC',
									'table DESC' => 'ORDER BY t.'.qi('table').' DESC',
									'ItemId DESC' => 'ORDER BY t.'.qi('ItemId').' DESC',
									'Sender DESC' => 'ORDER BY t.'.qi('Sender').' DESC',
									'ReportCount DESC' => 'ORDER BY t.'.qi('ReportCount').' DESC',
									'Timestamp DESC' => 'ORDER BY t.'.qi('Timestamp').' DESC',
									'' => ''), isset($params['sort_fop_chat']) ? $params['sort_fop_chat'] : '') ?: 'ORDER BY '.qi('t').'.'.qi('Timestamp').' DESC');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['ItemId'] = \Types\Integer::unpack($item['ItemId']);
											$item['Sender'] = \Types\Integer::unpack($item['Sender']);
											$item['ReportCount'] = \Types\Integer::unpack($item['ReportCount']);
											$item['Timestamp'] = intval($item['Timestamp']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['ItemId'] = \Types\Integer::unpack($item['ItemId']);
										$item['Sender'] = \Types\Integer::unpack($item['Sender']);
										$item['ReportCount'] = \Types\Integer::unpack($item['ReportCount']);
										$item['Timestamp'] = intval($item['Timestamp']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	if (isset($params['range_min_fop_chat_ItemId']) && isset($params['range_max_fop_chat_ItemId'])) {
		array_push($filters, _('ItemID') . ': ' . (\Types\Integer::print($params['range_min_fop_chat_ItemId'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_chat_ItemId'])
	));
	} else if (isset($params['range_min_fop_chat_ItemId'])) {
		array_push($filters, _('ItemID') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_chat_ItemId'])
	));
	} else if (isset($params['range_max_fop_chat_ItemId'])) {
		array_push($filters, _('ItemID') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_chat_ItemId'])
	));
	}
	if (isset($params['range_min_fop_chat_Sender']) && isset($params['range_max_fop_chat_Sender'])) {
		array_push($filters, _('Sender') . ': ' . (\Types\Integer::print($params['range_min_fop_chat_Sender'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_chat_Sender'])
	));
	} else if (isset($params['range_min_fop_chat_Sender'])) {
		array_push($filters, _('Sender') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_chat_Sender'])
	));
	} else if (isset($params['range_max_fop_chat_Sender'])) {
		array_push($filters, _('Sender') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_chat_Sender'])
	));
	}
	if (isset($params['range_min_fop_chat_ReportCount']) && isset($params['range_max_fop_chat_ReportCount'])) {
		array_push($filters, _('Report-Count') . ': ' . (\Types\Integer::print($params['range_min_fop_chat_ReportCount'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_chat_ReportCount'])
	));
	} else if (isset($params['range_min_fop_chat_ReportCount'])) {
		array_push($filters, _('Report-Count') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_chat_ReportCount'])
	));
	} else if (isset($params['range_max_fop_chat_ReportCount'])) {
		array_push($filters, _('Report-Count') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_chat_ReportCount'])
	));
	}
	
	if ( // Corner Case: Monat
		isset($params['range_min_fop_chat_Timestamp'])
		&& isset($params['range_max_fop_chat_Timestamp'])
		&& (date('d', $params['range_min_fop_chat_Timestamp']) == '01') //check first day of month
		&& (date('d', $params['range_max_fop_chat_Timestamp']) == date('t', $params['range_max_fop_chat_Timestamp'])) //check last day of month
		&& (date('Y-m', $params['range_min_fop_chat_Timestamp']) == date('Y-m', $params['range_max_fop_chat_Timestamp'])) //check if same year and month
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('first day of last month', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day of last month', $params['range_min_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('first day of next month', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day of next month', $params['range_min_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Zeit') . ': ' . strftime('%B', $params['range_min_fop_chat_Timestamp']) . ' ' . date('Y', $params['range_min_fop_chat_Timestamp']))
		]);
	} else if ( // Corner Case: Tag
		isset($params['range_min_fop_chat_Timestamp'])
		&& isset($params['range_max_fop_chat_Timestamp'])
		&& (date('Y-m-d', $params['range_min_fop_chat_Timestamp']) == (date('Y-m-d', $params['range_max_fop_chat_Timestamp'])))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day', $params['range_min_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('next day', $params['range_min_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Zeit') . ': ' . date('d.m.Y', $params['range_min_fop_chat_Timestamp']))
		]);
	} else if ( // Corner Case: Jahr
		isset($params['range_min_fop_chat_Timestamp'])
		&& isset($params['range_max_fop_chat_Timestamp'])
		&& (date('Y', $params['range_min_fop_chat_Timestamp']) == (date('Y', $params['range_max_fop_chat_Timestamp'])))
		&& ((date('m-d', $params['range_min_fop_chat_Timestamp']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_chat_Timestamp']) == '12-31'))
	) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('first day of January last year', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day of December last year', $params['range_min_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('first day of January next year', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day of December next year', $params['range_min_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">add_circle_outline</i>' : ''),
			htmlentities(_('Zeit') . ': ' . date('Y', $params['range_min_fop_chat_Timestamp']))
		]);
	} else if ( // Corner Case: Quartal
		isset($params['range_min_fop_chat_Timestamp'])
		&& isset($params['range_max_fop_chat_Timestamp'])
		&& ( (
		 ((date('m-d', $params['range_min_fop_chat_Timestamp']) == '01-01'))
		&& ((date('m-d', $params['range_max_fop_chat_Timestamp']) == '03-31')) )
		|| (
		 ((date('m-d', $params['range_min_fop_chat_Timestamp']) == '04-01'))
		&& ((date('m-d', $params['range_max_fop_chat_Timestamp']) == '06-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_chat_Timestamp']) == '07-01'))
		&& ((date('m-d', $params['range_max_fop_chat_Timestamp']) == '09-30')) )
		|| (
		 ((date('m-d', $params['range_min_fop_chat_Timestamp']) == '10-01'))
		&& ((date('m-d', $params['range_max_fop_chat_Timestamp']) == '12-31')) )
	) ) {
		array_push($filters, [
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
					query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('first day of -3 months', $params['range_min_fop_chat_Timestamp']).'&apos;;
					query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day of -3 months', $params['range_max_fop_chat_Timestamp']).'&apos;;
					reloadfop_chat(); ">remove_circle_outline</i>' : ''),
			($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="
				query[&apos;range_min_fop_chat_Timestamp&apos;] = &apos;'.strtotime('first day of +3 months', $params['range_min_fop_chat_Timestamp']).'&apos;;
				query[&apos;range_max_fop_chat_Timestamp&apos;] = &apos;'.strtotime('last day of +3 months', $params['range_max_fop_chat_Timestamp']).'&apos;;
				reloadfop_chat(); ">add_circle_outline</i>' : ''),	
			htmlentities(_('Zeit') . ': Q' . (ceil((date('m', $params['range_min_fop_chat_Timestamp']))/3)) . ' (' . date('d.m.', $params['range_min_fop_chat_Timestamp']) . ' - ' . date('d.m.Y', $params['range_max_fop_chat_Timestamp']) . ')')
		]);
	}
	else if (isset($params['range_min_fop_chat_Timestamp']) && isset($params['range_max_fop_chat_Timestamp'])) {
		array_push($filters, _('Zeit') . ': ' . (($params['range_min_fop_chat_Timestamp']) ? strftime(_('datetimeformat_php2'), intval($params['range_min_fop_chat_Timestamp'])) : '') . ' ' . _('filters_between') . ' ' . (($params['range_max_fop_chat_Timestamp']) ? strftime(_('datetimeformat_php2'), intval($params['range_max_fop_chat_Timestamp'])) : ''));
	} else if (isset($params['range_min_fop_chat_Timestamp'])) {
		array_push($filters, _('Zeit') . ': ' . _('filters_from') . ' ' . (($params['range_min_fop_chat_Timestamp']) ? strftime(_('datetimeformat_php2'), intval($params['range_min_fop_chat_Timestamp'])) : ''));
	} else if (isset($params['range_max_fop_chat_Timestamp'])) {
		array_push($filters, _('Zeit') . ': ' . _('filters_to') . ' ' . (($params['range_max_fop_chat_Timestamp']) ? strftime(_('datetimeformat_php2'), intval($params['range_max_fop_chat_Timestamp'])) : ''));
	}if (isset($params['filter_fop_chat_ItemId'])) {
		if ($params['filter_fop_chat_ItemId'] == '_null') {
			array_push($filters, _('ItemID') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_chat_ItemId']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('ItemID') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_chat_Sender'])) {
		if ($params['filter_fop_chat_Sender'] == '_null') {
			array_push($filters, _('Sender') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_chat_Sender']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Sender') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_chat_Message'])) {
		if ($params['filter_fop_chat_Message'] == '_null') {
			array_push($filters, _('Nachricht') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_chat_Message']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Nachricht') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_chat_ReportCount'])) {
		if ($params['filter_fop_chat_ReportCount'] == '_null') {
			array_push($filters, _('Report-Count') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_chat_ReportCount']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Report-Count') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_chat_Timestamp'])) {
		if ($params['filter_fop_chat_Timestamp'] == '_null') {
			array_push($filters, _('Zeit') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_chat_Timestamp']))->all() AS $val) {
				$value = ($val) ? strftime(_('datetimeformat_php2'), intval($val)) : '';
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Zeit') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_chat_table'])) {
		if ($params['filter_fop_chat_table'] == '_null') {
			array_push($filters, _('Tabelle') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_chat_table']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Tabelle') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_fop_chat_Message'])) {
		array_push($filters, _('Message') . ' ' . _('filter_contains') . ' ' . $params['search_fop_chat_Message']);
	}if (isset($params['search_fop_chat_table'])) {
		array_push($filters, _('table') . ' ' . _('filter_contains') . ' ' . $params['search_fop_chat_table']);
	}if (isset($params['searchnot_fop_chat_Message'])) {
		array_push($filters, _('Message') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_chat_Message']);
	}if (isset($params['searchnot_fop_chat_table'])) {
		array_push($filters, _('table') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_chat_table']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_chat_\')) delete query[q];} reloadfop_chat(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_chat') {
	\FOP\Session::setPayload('dv-fop_chat', [
		'id' => 'fop_chat',
		'tbl' => 'fop_chat',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_chat::stepURL('fop_chat', 'XXX', -1),
		'next' => \DataViewRouter\Fop_chat::stepURL('fop_chat', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_chat::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



